/*******************************************************************************
**	CS5534Lib.h				CS5534 A/D driver file  
**
**   
**  Revised    10/30/07   MJB
**
**
**  Copyright 2007  Oceanographic Embedded Systems
**  Release or transfer of this source code is prohibited
**  without the written permisson of OES.
*******************************************************************************/



// Channel definitions to allow remapping for layout
#define CHAN1   0
#define CHAN2   1
#define CHAN3   2
#define CHAN4   3

#define CHAN5   0
#define CHAN6   1
#define CHAN7   2
#define CHAN8   3


// bit definitions for CS5534 command register as setup commands
#define cmdbit  	0x00
#define arabit 	 	0x40
// channel select bits are bits D5 and D4
#define readbit 	0x08
#define writebit 	0x00
#define offsetreg	0x01
#define gainreg		0x02
#define configreg	0x03
#define cvtdata		0x04
#define setupreg	0x05

// bit definitions for CS5534 command register as convert commands
#define cvtbit  	0x80
#define mcbit   	0x40
#define normcvt 	0x00
#define selfoffcal 	0x01
#define selfgaincal 0x02
#define sysoffcal	0x05
#define sysgaincal	0x06

#define WRITECONFIG		0x03
#define READCONFIG		0x0B
#define READDATA    	0x0C
#define CONVERT1  		0x80
#define CONVERTMULTIPLE 0xC0
#define cmdreadconvert  0x0C

#define POWERSAVE  0
#define POWERNORMAL 1


extern short spdidx;

extern ushort setups[16];

extern const short spdbits[10];

extern const float speeds[11];
void CS5534SaveCFQSM(void);
void CS5534RestoreCFQSM(void);
void CS5534RestoreSetup(void);
void CS5534SerialReset(void);
void CS5534SetupQSM(ushort slot1);
void SetAllSpeeds( short sdx);
void SetSpeed(short chan, short sdx);
void SetBipolar(short chan, bool bipolar);
void ShowSetup(void);
void CS5534Init(ushort slot1);
long CS5534GetValue(short chan);
void CS5534RequestData(short chan);
bool CS5534DataAvailable(short chan);
long CS5534Result(short chan);
void CS5534ToArray(short chan, void *arptr, long numvals);
void SetGain(short chan, ushort gainval);
long OffsetCal(short chan);
long SysOffset(short chan);
void CS5534SetPower(short level, short chip);
void CS5534SetGainCal(short chan, ulong gaincal);
void CS5534SetOffCal(short chan, ulong offcal);
ulong CS5534GetOffCal(short chan);
ulong CS5534GetGainCal(short chan);

long GainCal(short chan);
void ShortInputs(void);
void ShowQSPI(void);